#
# Conditional build:
%bcond_without	X	# without X based interfaces (implies libX11 deps)
%bcond_without	alsa	# without ALSA support
%bcond_with	arts	# enable ARTS support (implies also glib(2) deps)
%bcond_with	esd	# enable ESD support
%bcond_with	jack	# enable JACK support
%bcond_with	nas	# enable NAS support
%bcond_with	vorbis	# enable Ogg Vorbis support
#
Summary:	TiMidity++ - MIDI to WAV converter and player
Summary(pl):	TiMidity++ - konwerter do WAV oraz odtwarzacz plikw MIDI
Summary(pt_BR):	Sintetizador MIDI por software
Summary(ru):	 MIDI      WAV 
Summary(uk):	 MIDI-̦     WAV 
Name:		TiMidity++
Version:	2.13.0
Release:	3
License:	GPL
Vendor:		Masanao Izumo <mo@goice.co.jp>
Group:		Applications/Sound
Source0:	http://dl.sourceforge.net/timidity/%{name}-%{version}.tar.bz2
# Source0-md5:	63284981e1ac81fce2b53cc4b1f4c468
Source1:	http://archive.cs.umbc.edu/pub/midia/instruments.tar.gz
# Source1-md5:	4959787a78ee39d44a36185bd303cf20
Source2:	britepno.pat.bz2
# Source2-md5:	324e265362f812883024b58cf3470d1a
Source3:	pistol.pat.bz2
# Source3-md5:	f961325db679de6e0ea402ebe6a268f9
Source4:	timidity.cfg
URL:		http://timidity.sourceforge.net/
%{?with_alsa:BuildRequires:	alsa-lib-devel}
%{?with_arts:BuildRequires:	arts-devel}
BuildRequires:	autoconf
%{?with_esd:BuildRequires:	esound-devel}
%{?with_jack:BuildRequires:	jack-audio-connection-kit-devel}
%{?with_X:BuildRequires:	gtk+-devel}
%{?with_X:BuildRequires:	motif-devel}
%{?with_nas:BuildRequires:	nas-devel}
BuildRequires:	ncurses-devel
BuildRequires:	slang-devel
%{?with_X:BuildRequires:	tk-devel >= 8.3.2}
%{?with_vorbis:BuildRequires:	libvorbis-devel}
%{?with_X:Provides:	%{name}(X) = %{version}-%{releaase}}
Obsoletes:	timidity
Obsoletes:	timidity++
Obsoletes:	timidity++-X11
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
TiMidity++ is a converter that converts some of MIDI files ( formats :
Standard MIDI file (MID), Recomposer files (RCP, R36, G18, G36) and
Module file (mod) ) into formatted audio file (ex. RIFF WAVE).
TiMidity uses Gravis Ultrasound-compatible patch files or Soundfonts
(sfx, sf2) to generate digital audio data from MIDI files. The digital
audio data generated by TiMidity can be stored in a file for
processing, or played in real time through an audio device. In real
time playing, TiMidity if able to show the lyric contained in KAR file
or WRD file.

%description -l pl
TiMidity++ jest konwerterem z niektrych plikw MIDI (formaty:
Standard MIDI (MID), Recomposer (RCP, R36, G18, G36), Module (mod)) do
plikw audio (np. RIFF WAVE). Do generowania danych z plikw MIDI
TiMidity uywa patchy takich jak Gravis Ultrasound albo Soundfontw
(sfx, sf2). Cyfrowe dane audio mog by zapisane do pliku albo
odtwarzane w czasie rzeczywistym. Przy odtwarzaniu TiMidity moe
pokazywa sowa zawarte w pliku KAR lub WRD.

%description -l pt_BR
O TiMidity++  um sintetizador MIDI por software. Este pacote permite
ouvir arquivos do tipo MIDI com a mesma qualidade de som que as placas
que utilizam o recurso de "wavetable" via hardware (como a AWE32),
mesmo que esta no possua o recurso de "wavetable" (a SB16 por
exemplo).

%description -l ru
 MIDI ,     MIDI
 .      GUS/patch,
      SoundFont.
    MIDI   
 .

%description -l uk
 MIDI ̦,   Ҧ Ц Ԧ MIDI
 . դ  Ԧ  Ԧ GUS/patch,
ͦ   SoundFont.
դ צͦ ˦  MIDI   
 .

%package gspdir
Summary:	Directory for TiMidity++ instruments
Summary(pl):	Katalog na instrumenty TiMidity++
Group:		Applications/Sound

%description gspdir
Directory where TiMidity++ instruments should be placed in.

%description gspdir -l pl
Katalog, w ktrym powinny by instalowane instrumenty dla TiMidity++.

%package instruments
Summary:	Instruments for TiMidity++
Summary(pl):	Instrumenty dla TiMidity++
Summary(pt_BR):	Instrumentos bsicos para o TiMidity++
Group:		Applications/Sound
Requires:	%{name}-gspdir = %{version}-%{release}
Obsoletes:	timidity-patches

%description instruments
Instruments for TiMidity++.

%description instruments -l pl
Instrumenty dla TiMidity++.

%description instruments -l pt_BR
Este pacote inclui um conjunto bsico de instrumentos (chamados de
patches no meio musical) para o TiMidity++.

%package gtk
Summary:	GTK+ interface for TiMidity++
Summary(pl):	Interfejs TiMidity++ oparty o bibliotek gtk+
Group:		Applications/Sound
Requires:	%{name}(X) = %{version}-%{release}

%description gtk
gtkmidi - GTK+ interface for TiMidity++.

%description gtk -l pl
gtkmidi - interfejs do TiMidity++ oparty o bibliotek gtk+.

%package motif
Summary:	Motif interface for TiMidity++
Summary(pl):	Interfejs TiMidity++ oparty o Motif
Group:		Applications/Sound
Requires:	%{name}(X) = %{version}-%{release}

%description motif
xmmidi - Motif interface for TiMidity++.

%description motif -l pl
xmmidi - interfejs do TiMidity++ oparty o bibliotek Motif.

%package slang
Summary:	Slang interface for TiMidity++
Summary(pl):	Interfejs TiMidity++ oparty o bibliotek Slang
Group:		Applications/Sound
Requires:	%{name} = %{version}-%{release}

%description slang
Slang interface for TiMidity++.

%description slang -l pl
Interfejs do TiMidity++ oparty o bibliotek Slang.

%package tcltk
Summary:	Tcl/Tk interface for TiMidity++
Summary(pl):	Interfejs TiMidity++ oparty o Tcl/Tk
Group:		Applications/Sound
Requires:	%{name}(X) = %{version}-%{release}

%description tcltk
tkmidi - Tcl/Tk interface for TiMidity++.

%description tcltk -l pl
tkmidi - interfejs do TiMidity++ oparty o Tcl/Tk.

%package vt100
Summary:	VT100 interface for TiMidity++
Summary(pl):	Interfejs TiMidity++ dziaajcy na terminalu VT100
Group:		Applications/Sound
Requires:	%{name} = %{version}-%{release}

%description vt100
VT100 interface for TiMidity++.

%description vt100 -l pl
Interfejs do TiMidity++ mogcy dziaa na terminalu VT100.

%package xaw
Summary:	Athena interface for TiMidity++
Summary(pl):	Interfejs TiMidity++ oparty o Athena Widgets
Group:		Applications/Sound
Requires:	%{name}(X) = %{version}-%{release}

%description xaw
xawmidi - Athena interface for TiMidity++.

%description xaw -l pl
xawmidi - interfejs do TiMidity++ oparty o biblitek widgetw Athena.

%package xskin
Summary:	"X Skin" interface for TiMidity++
Summary(pl):	Interfejs TiMidity++ "X Skin" 
Group:		Applications/Sound
Requires:	%{name}(X) = %{version}-%{release}
Obsoletes:	TiMidity++ < 2.13.0-3

%description xskin
xskinmidi - "X Skin" interface for TiMidity++.

%description xskin -l pl
xskinmidi - interfejs do TiMidity++ "X Skin".

%prep
%setup -q

for f in doc/ja_JP.eucJP/README*; do
	mv -f $f ${f}.ja
done

%build
cp -f /usr/share/automake/config.sub autoconf
%{__autoconf}

AUDIO=oss%{?with_alsa:,alsa}%{?with_arts:,arts}%{?with_esd:,esd}\
%{?with_jack:,jack}%{?with_nas:,nas}%{?with_vorbis:,vorbis}

%configure \
	%{?with_alsa:--enable-alsaseq=dynamic} \
	--enable-audio=$AUDIO \
	--enable-dynamic \
	%{?with_X:--enable-gtk=dynamic} \
	--enable-emacs=dynamic \
	%{?with_X:--enable-motif=dynamic} \
	--enable-ncurses=dynamic \
	--enable-network \
	--enable-server \
	--enable-slang=dynamic \
	%{?with_X:--enable-spectrogram} \
	%{?with_X:--enable-tcltk=dynamic} \
	--enable-vt100=dynamic \
	%{?with_X:--enable-xaw=dynamic} \
	%{?with_X:--enable-xskin=dynamic} \
	--with-default-path=%{_sysconfdir} \
	--with-elf \
	%{!?with_X:--without-x}

%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_sysconfdir},%{_datadir}/GUSpatches}

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

## based on timidity/timidity.c
##ln -s timidity $RPM_BUILD_ROOT%{_bindir}/kmidi # does it work?
ln -sf timidity $RPM_BUILD_ROOT%{_bindir}/gtkmidi
ln -sf timidity $RPM_BUILD_ROOT%{_bindir}/tkmidi
ln -sf timidity $RPM_BUILD_ROOT%{_bindir}/xmmidi
ln -sf timidity $RPM_BUILD_ROOT%{_bindir}/xawmidi
ln -sf timidity $RPM_BUILD_ROOT%{_bindir}/xskinmidi

install -d $RPM_BUILD_ROOT%{_mandir}/ja/man{1,5}
install doc/ja_JP.eucJP/timidity.1 $RPM_BUILD_ROOT%{_mandir}/ja/man1
install doc/ja_JP.eucJP/timidity.cfg.5 $RPM_BUILD_ROOT%{_mandir}/ja/man5

install %{SOURCE4} $RPM_BUILD_ROOT%{_sysconfdir}

cd $RPM_BUILD_ROOT%{_datadir}/GUSpatches
tar xzf %{SOURCE1}
mv -f instruments/* .
rmdir instruments
bzip2 -cd %{SOURCE2} > britepno.pat
bzip2 -cd %{SOURCE3} > pistol.pat

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc AUTHORS ChangeLog* NEWS README TODO doc/C/{CHANGES*,FAQ,README.[!tx]*}
%lang(ja) %doc README.ja doc/ja_JP.eucJP/README.[!tx]*.ja
%attr(755,root,root) %{_bindir}/timidity
%config(noreplace) %verify(not size mtime md5) %{_sysconfdir}/timidity.cfg
%dir %{_libdir}/timidity
%attr(755,root,root) %{_libdir}/timidity/interface_e.so
%attr(755,root,root) %{_libdir}/timidity/interface_n.so
%{_libdir}/timidity/interface_e.txt
%{_libdir}/timidity/interface_n.txt
%{?with_X:%{_libdir}/timidity/bitmaps}
%{_mandir}/man1/timidity.1*
%{_mandir}/man5/timidity.cfg.5*
%lang(ja) %{_mandir}/ja/man1/timidity.1*
%lang(ja) %{_mandir}/ja/man5/timidity.cfg.5*
%if %{with alsa}
# could be separated, but audio modules are always compiled in,
# so timidity is linked with alsa-lib anyway
%attr(755,root,root) %{_libdir}/timidity/interface_A.so
%{_libdir}/timidity/interface_A.txt
%endif

%files gspdir
%defattr(644,root,root,755)
%dir %{_datadir}/GUSpatches

%files instruments
%defattr(644,root,root,755)
%{_datadir}/GUSpatches/*

%if %{with X}
%files gtk
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/gtkmidi
%attr(755,root,root) %{_libdir}/timidity/interface_g.so
%{_libdir}/timidity/interface_g.txt
%endif

%if %{with X}
%files motif
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/xmmidi
%attr(755,root,root) %{_libdir}/timidity/interface_m.so
%{_libdir}/timidity/interface_m.txt
%endif

%files slang
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/timidity/interface_s.so
%{_libdir}/timidity/interface_s.txt

%if %{with X}
%files tcltk
%defattr(644,root,root,755)
%doc doc/C/README.tk
%lang(ja) %doc doc/ja_JP.eucJP/README.tk.ja
%attr(755,root,root) %{_bindir}/tkmidi
%attr(755,root,root) %{_libdir}/timidity/interface_k.so
%{_libdir}/timidity/interface_k.txt
%{_libdir}/timidity/tclIndex
%{_libdir}/timidity/*.tcl
%endif

%files vt100
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/timidity/interface_T.so
%{_libdir}/timidity/interface_T.txt

%if %{with X}
%files xaw
%defattr(644,root,root,755)
%doc doc/C/README.xaw
%lang(ja) %doc doc/ja_JP.eucJP/README.xaw.ja
%attr(755,root,root) %{_bindir}/xawmidi
%attr(755,root,root) %{_libdir}/timidity/interface_a.so
%{_libdir}/timidity/interface_a.txt

%files xskin
%defattr(644,root,root,755)
%doc doc/C/README.xskin
%lang(ja) %doc doc/ja_JP.eucJP/README.xskin.ja
%attr(755,root,root) %{_bindir}/xskinmidi
%attr(755,root,root) %{_libdir}/timidity/interface_i.so
%{_libdir}/timidity/interface_i.txt
%endif
